/*
 . . .
23:51 18.05.2011
*/

//***************************************************************
// This code is distributed under the GNU Public License
//		which can be found at http://www.gnu.org/licenses/gpl.txt
//***************************************************************

// 
//plavno   

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h> /*F_CPU = 4000000; _delay_ms max = 65,535ms; _delay_us max = 192us */


#include "term_fi.h"

/*
4000000 meg 
*/ 


ISR(TIMER2_COMP_vect){
	ON(OUT_TRIAC);
	_delay_us(20);
	OFF(OUT_TRIAC);
}

ISR(SIG_INTERRUPT1)
{
	SFIOR|=_BV(PSR2);// Bit 0  PSR10: Prescaler Reset Timer/Counter1 and Timer/Counter0
	TCNT2=0;
	OCR2=power;
}

void avr_init(void)
{
	TIMSK=_BV(OCIE2);
	
	MCUCR=(1<<ISC11)|(0<<ISC10);//1 1 The rising edge  //1 0 The falling edge of INT1 generates an interrupt request.
	GICR=_BV(INT1);//External Interrupt Request 0 Enable
	
	DDRZN|=BITZN;//|SEG_D;//      
	DDRLED=0xFF;
	
	DRIVER(PIN_INTERRUPT,PULLUP);
	DRIVER(KEY_PRESS,PULLUP);
	DRIVER(OUT_TRIAC,OUT);
	DRIVER(OUT_RELE,OUT);
	DRIVER(OUT_ALARM_LED,OUT);
	DRIVER(SOUNDER,OUT);
	DRIVER(SOUNDER_LED,OUT);
	DRIVER(OUT_ON_NAGREV,OUT);

	OCR2=220;
	TCCR2=(1<<CS22)|(1<<CS21)|(0<<CS20);
	
	OCR1A=4000;// 1 
	TCCR1B=(1<<CS10)|(1<<WGM12);// ctc mode
	
	sei();

    return;
}
//-------------------EEPROM-------------------------
unsigned char EEPROM_read(unsigned int uiAddress)
{
	while(EECR & (1<<EEWE));
	EEAR = uiAddress;
	EECR |= (1<<EERE);
	return EEDR;
}

void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	if ( EEPROM_read(uiAddress)!=ucData){
		while(EECR & (1<<EEWE));
		cli();
		asm("wdr");
		EEAR = uiAddress;
		EEDR = ucData;
		EECR |= (1<<EEMWE);
		EECR |= (1<<EEWE);
		sei();
		}
}
//-------------END------EEPROM----------------------


//**********1wire************

unsigned char readbit(void){
unsigned char i;
	cli();
	DDR_1wire|=pwire0;//line down

	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");//1.25us
	DDR_1wire&=~pwire0;//line up through 1.25us
	_delay_us(11);
	i=PIN_1wire;
	sei();
	_delay_us(47);
	return i;
}

void readbyte(unsigned char *pw0) {
DDR_1wire&=~pwire0;
PORT_1wire&=~pwire0;

uint8_t rezult=0;
for(uint8_t i=0, r=1; i<8; i++){
	uint8_t p=readbit();
	if ( p & pwire0 ) rezult|=r;
	r<<=1;	
	}
PORT_1wire|=out_1wire;
DDR_1wire|=out_1wire;
*pw0=rezult;
}

void writebit0(void){
	cli();
	DDR_1wire|=pwire0;
	_delay_us(60);
	DDR_1wire&=~pwire0;
	sei();
}

void writebit1(void){
	cli();
	DDR_1wire|=pwire0;
	_delay_us(3);
	DDR_1wire&=~pwire0;
	sei();
	_delay_us(58);
}

void writebyte(unsigned char byte){
unsigned char i;
	DDR_1wire&=~pwire0;
	PORT_1wire&=~pwire0;
	for(i=0; i<8; i++){
		if ( byte & _BV(0) )
			writebit1();
			else
			writebit0();
		byte>>=1;
		}
	PORT_1wire|=out_1wire;
	DDR_1wire |=out_1wire;
}

void detectPresence(void){
unsigned char i;
	DDR_1wire&=~pwire0;
	PORT_1wire&=~pwire0;
	
	out_1wire=pwire0;
	
	DDR_1wire|=pwire0;
	_delay_ms(0.48);
	DDR_1wire&=~pwire0;
	
	cli();
	_delay_us(60);
	i=PIN_1wire;
	sei();
	
	if ( i & pwire0 ) {
		out_1wire=0; 
		OFF(OUT_TRIAC);
		ON(OUT_RELE);//PORT_OUT |= OUT_RELE; 
		OFF(OUT_ON_NAGREV);//PORT_OUT&=~OUT_ON_NAGREV; 
		}//out_1wire&=~pwire0; 
	
	if ( out_1wire ){
		_delay_ms(0.42);
		i=PIN_1wire;
		if (!( i & pwire0 )) {
			out_1wire=0; 
			OFF(OUT_TRIAC);
			ON(OUT_RELE);//PORT_OUT |= OUT_RELE; 
			OFF(OUT_ON_NAGREV);//PORT_OUT&=~OUT_ON_NAGREV; 
			}
		}
	if (out_1wire==0) state_wire=0;
	else{
	PORT_1wire|=out_1wire;
	DDR_1wire|=out_1wire;
	}
}

//***************************
void scratchpad_save(void){
	detectPresence();
	if (out_1wire){
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x4E);//WRITE SCRATCHPAD [4Eh]
		writebyte(0);//	TH
		writebyte(0);//	TL
		writebyte(0x7F);//	20 Statys 10bit //writebyte(0x60);//	Statys 12bit byte 4 Configuration Register* 0x7F - 12 bit 750mSek; 1F-9bit 94msek
		detectPresence();
		if (out_1wire){// EEPROM
			writebyte(0xCC);//SKIP ROM [CCh]
			writebyte(0x48);//COPY SCRATCHPAD [48h]
			
			PORT_1wire|=out_1wire;
			DDR_1wire|=out_1wire;
			}
		}
}
//*******end***1wire************

/**************************************************
void alarm_T_top_40_5gr(void){
	if ( Temperatura > (uint16_t)(40.5*16) ) 	
		{										
		ON(OUT_RELE);//PORT_OUT |= OUT_RELE; 
		ON(OUT_ALARM_LED);//PORT_OUT |= OUT_ALARM_LED;
		OFF(OUT_ON_NAGREV);//PORT_OUT&=~OUT_ON_NAGREV;
		power=220; 
		status_nagrev=4;
		}
}*/
//**************************************************
void receive_t(void){

	if ( state_wire==0 )
	{
	state_wire=1;
	detectPresence();
	return;
	}
	
	if ( state_wire==1 )
	{
	state_wire=2;
	writebyte(0xCC);//SKIP ROM [CCh]
	writebyte(0x44);//CONVERT T [44h]
	time_wire=125;//87;  // time= time_wire/100
	return;
	}
	
	if ( state_wire==2 )
	{
	if (!time_wire) state_wire=3;
	return;
	}

	if ( state_wire==3 )
	{
	state_wire=4;
	detectPresence();
	return;
	}
	
	if ( state_wire==4 )
	{
	state_wire=5;
	writebyte(0xCC);//SKIP ROM [CCh]
	writebyte(0xBE);//READ SCRATCHPAD [BEh]
	readbyte(temperature);
	readbyte(temperature+1);
	uint16_t t;
	t=( ((unsigned int)(temperature[1]<<8))|temperature[0] ); 
	
	static uint8_t TerrCount;
	static uint16_t Told;
	if ( t> (Told+10*16) ){
		if (++TerrCount>=3){
			TerrCount=0;
			Temperatura=t;
			Told=t;
			}
		}else{
		TerrCount=0;
		Temperatura=t;
		Told=t;	
		}
	return;
	}
	
	if ( state_wire==5 )
	{
	state_wire=0;
	
	if ( Temperatura > (uint16_t)(40.5*16) ) 	//   ( )   
		{										
		ON(OUT_RELE);//PORT_OUT |= OUT_RELE; 
		ON(OUT_ALARM_LED);//PORT_OUT |= OUT_ALARM_LED;
		OFF(OUT_ON_NAGREV);//PORT_OUT&=~OUT_ON_NAGREV;
		power=220; 
		status_nagrev=4;
		}

	//static uint8_t tmp_power=1;
	switch(status_nagrev)
	{
	case(0):
		if	( Temperatura >= porog-4*16 ) {	
			Old_Temperatura=Temperatura;
			//power=120;// .. OCR2 max 155   (10mSek)
			tmp_power=70;
			ON(OUT_ON_NAGREV);//PORT_OUT|=OUT_ON_NAGREV;
			status_nagrev=1;
			}
		else{
			tmp_power=power=1;//  
			ON(OUT_ON_NAGREV);//PORT_OUT|=OUT_ON_NAGREV;
			}
		
		break;

	case(1):
		if ( Temperatura >= porog ){
			Old_Temperatura=0;
			tmp_power=70;
			power=220;
			OFF(OUT_ON_NAGREV);//PORT_OUT&=~OUT_ON_NAGREV;	
			status_nagrev=2;
			}
			else
			{
			if ( Temperatura > Old_Temperatura+1 )
				{
				if ( Temperatura > Old_Temperatura+2 ) 
					if ( tmp_power<100 ) tmp_power+=5;
				Old_Temperatura=Temperatura;
				power=130;//,   
				OFF(OUT_ON_NAGREV);//PORT_OUT&=~OUT_ON_NAGREV;
				}
				else
				{
				if (tmp_power>2) tmp_power-=2;
				power=tmp_power;// 
				ON(OUT_ON_NAGREV);//PORT_OUT|=OUT_ON_NAGREV;
				}
			}
		break;
	
	case(2):
		if ( Temperatura < porog ) 	//       time_power_off  
			status_nagrev=3;		//   3    50% 
			else
		break;

	case(3):
		if ( Temperatura <= porog )
			{
			#define T_NO_POWER	0
			#define NAGREV_OFF	1
			#define T_BOTTOM	2
			#define T_TOP		3
			
			if ( (power_flag==NAGREV_OFF)||(power_flag==T_NO_POWER) ) power=140;
			power_flag=T_BOTTOM;
			uint8_t inc=1;
			if ( Temperatura+1 < porog ) inc=2;
			if ( Temperatura+2 < porog ) inc=5;
			
			if ( Temperatura != porog )
				if (tmp_power>inc) tmp_power-=inc;//  
			
			//power=tmp_power;
			ON(OUT_ON_NAGREV);//PORT_OUT|=OUT_ON_NAGREV;
			}
		else 
		if ( Temperatura > porog )
			{//  
			if ( power_flag==T_BOTTOM ){
				if (tmp_power<100)
					power=100;
				else 
				power=tmp_power;
				}
			power_flag=T_TOP;
			
			uint8_t inc=1;
			if ( Temperatura > porog+1 ) {
				power_flag=T_NO_POWER; 
				power=220;
				if ( Temperatura > porog+2 ) {inc=3;}
				}
			
			if (Temperatura>Old_Temperatura) {//      .
				if (tmp_power<145) tmp_power+=inc;
				}
			OFF(OUT_ON_NAGREV);//PORT_OUT&=~OUT_ON_NAGREV;
			}

		Old_Temperatura=Temperatura;
		break;
	case(4):
		if ( Temperatura < porog )
			{
			OFF(OUT_RELE);//PORT_OUT &= ~OUT_RELE;
			ON(OUT_ON_NAGREV);//PORT_OUT|=OUT_ON_NAGREV;
			power=1;
			}
		else//	if ( Temperatura >= porog )
			{
			ON(OUT_RELE);//PORT_OUT |= OUT_RELE;
			OFF(OUT_ON_NAGREV);//PORT_OUT&=~OUT_ON_NAGREV;
			power=220;
			}
		break;
	}

	alarm_T=0;
	if ( Temperatura < 35*16 ) alarm_T=1;
	else
	if ( Temperatura > 40*16 ) alarm_T=2;
	
	
//---------------------------------------------------------------	
	}
}

//**************************************
void result_in_bcd(int result)
{//0000 0000 0000 (1)0000  // (2)0000 (3)0000 (4)0000 (5)0000 hi2 hi3 low4 low5
    unsigned char dig_out=0;
	//bcd_num1=0;
	bcd_num2=0;
	bcd_num3=0;
	bcd_num4=0;

	//while (result >= 1000) {
	// result -= 1000;
 	// dig_out ++;
	//}
	//bcd_num1=dig_out;
    //dig_out = 0;
	while (result >= 100)  {
 	 result -= 100;
	 dig_out ++;
	 }
	bcd_num2=dig_out;
	dig_out = 0;
	while (result >= 10)   {
	 result -= 10;
	 dig_out ++;
	 }
	bcd_num3=dig_out;
	bcd_num4=result;
}
//**************************************
void t_in_bcd(signed int t, unsigned char pin_wire){

	 if ( ((pin_wire & out_1wire)==0)&&(state<=1) ){
	 	led_buffer[0]=sG;
		led_buffer[1]=sG;
		led_buffer[2]=sG;
		}
		else
		{

		result_in_bcd( t );
		
		if ( bcd_num2 ){ 
			led_buffer[0]=font[bcd_num2]; 
			}

		led_buffer[1]=font[bcd_num3]|sH; 
		led_buffer[2]=font[bcd_num4]; 
		}
}

/*/-------------------------------------
void led_off(void)
{
	// 
#ifdef katod
	PORTZN |= BITZN;
	PORTLED=0;
	
#else
	PORTZN &= ~BITZN;
	PORTLED=0xFF;
#endif
}*/

/*/-------------------------------------
void display(void)
{
#ifdef katod
	//PORTZN |= BITZN;
	
	if ( znmesto==0 )	PORTZN &= ~ZN0;//PORTZN &= ~ZN0;//
	else
	if ( znmesto==1 )	PORTZN &= ~ZN1;//PORTZN &= ~ZN1;//
	else
	if ( znmesto==2 )	PORTZN &= ~ZN2;

	PORTLED=led_buffer[znmesto];
#else
	//PORTZN &= ~BITZN;

	if ( znmesto==0 )	PORTZN |= ZN0;//PORTZN &= ~ZN0;//
	else
	if ( znmesto==1 )	PORTZN |= ZN1;//PORTZN &= ~ZN1;//
	else
	if ( znmesto==2 )	PORTZN |= ZN2;

	PORTLED=~led_buffer[znmesto];
#endif
}*/
//-------------------------------------

void led_off(void)
{
	// 
#ifdef katod
	PORTZN |= BITZN;
	PORTLED=0;
	//PORT_SEG_D&=~SEG_D;
	
#else
	PORTZN &= ~BITZN;
	PORTLED=0xFF;// & ~PIN_OCR2;
	//PORT_SEG_D|= SEG_D;
#endif
}
//-------------------------------------
void display(void)
{
#ifdef katod
	//PORTZN |= BITZN;
	
	if ( znmesto==0 )	PORTZN &= ~ZN0;
	else
	if ( znmesto==1 )	PORTZN &= ~ZN1;
	else
	if ( znmesto==2 )	PORTZN &= ~ZN2;

	PORTLED=led_buffer[znmesto];// & ~PIN_OCR2;
	//if ( led_buffer[znmesto] & SEG_D ) PORT_SEG_D|=SEG_D;  
#else
	//PORTZN &= ~BITZN;
	//PORT_SEG_D|=SEG_D;

	if ( znmesto==0 )	PORTZN |= ZN0;
	else
	if ( znmesto==1 )	PORTZN |= ZN1;
	else
	if ( znmesto==2 )	PORTZN |= ZN2;

	PORTLED=~led_buffer[znmesto];// &~PIN_OCR2;
	//if ( led_buffer[znmesto] & SEG_D ) PORT_SEG_D&=~SEG_D;
#endif
}
//-------------------------------------

void on_state3(void){
	time_flag &= ~_BV(_blank);
	time_blank=20;//0.8sek
	count_num=0;
	TimeKey=0;
	state=3;
}

void skan_key(void){

	switch (state)
	{
    case (0):
		if ( ACTIVE(KEY_PRESS) ){
			TimeKey=0;
			state=1;
			}
		break;

    case (1):
		if ( ACTIVE(KEY_PRESS) ){
			if ( TimeKey >= TIME_T1(3) ) {tmp_porog=(porog*5+2)/8; state=2;}
			}
			else
			state=0;
		break;

    case (2):
		if ( ! ACTIVE(KEY_PRESS)  ){
			on_state3();
			}
		break;
	
	case (3):
		if ( ACTIVE(KEY_PRESS) )
		{
			TimeKey=0;
			state=4;
		}
		else
		{
			if ( TimeKey >= TIME_T1(4) ) 
				{
				uint8_t crc;
				porog=(tmp_porog*8+2)/5;
				EEPROM_write(ADR_EEP,  (uint8_t)(porog>>8));	
				EEPROM_write(ADR_EEP+1,(uint8_t)porog);
				
				crc=(uint8_t)porog+(uint8_t)(porog>>8);
				EEPROM_write(ADR_EEP+2, crc);
				time_flag &= ~_BV(_crc_error);
				state=0;
				status_nagrev=0;
				}
		}
		break;
    case (4):
		if ( ACTIVE(KEY_PRESS) )
		{
			if ( TimeKey >= TIME_T1(0.05) ) 
				{
				if (++tmp_porog==401) tmp_porog=350;
				if (count_num	< sizeof(time_pause)/2-1 ) count_num++;
				state=5;
				}
		}
		else
		{
			state=2;
		}
		break;
	case (5):
		if ( ACTIVE(KEY_PRESS) )
		{
			if ( TimeKey >= time_pause[count_num] ) 
			{
			TimeKey=0;
			state=3;
			}
		}
		else
		{
			on_state3();
		}
			
		break;

    default:
		state=0;
		break;
	}


}

//-------------------------------------
void data_led(void)
{
unsigned char i;

for(i=0;i<sizeof(led_buffer);i++)
	led_buffer[i]=0;


	switch (state)
	{
    case (0):
    case (1):
		if ( time_flag & _BV(_crc_error) ){
			led_buffer[0]=font[f_E];
			led_buffer[1]=font[f_E];
			led_buffer[2]=font[f_P];
			}
			else
		t_in_bcd(Temperatura*10>>4,pwire0);
		break;

    case (2):
		led_buffer[0]=font[f_y];
		led_buffer[1]=font[f_C];
		led_buffer[2]=font[f_t];
		break;
	
	case (3):
		if ( (!( time_flag & _BV(_blank) )) || ( ACTIVE(KEY_PRESS) ) )
						t_in_bcd(tmp_porog,pwire0);
		break;
	
	case (4):
	case (5):
		t_in_bcd(tmp_porog,pwire0);
		break;
		
    default:
		;
		break;
	}



}
//-------------------------------------

void data_eeprom_read(void){

uint8_t crc;
int16_t eep_data;
	
	eep_data=(uint16_t)(EEPROM_read(ADR_EEP)<<8);
	eep_data|=EEPROM_read(ADR_EEP+1);
	
	crc=(uint8_t)eep_data+(uint8_t)(eep_data>>8);
	
	if ( crc==EEPROM_read(ADR_EEP+2) ) 
		porog=eep_data;
		else
		time_flag |= _BV(_crc_error);
}

int main(void)
{
uint8_t t10ms=10, tLed=4;
	cli();
	avr_init();
	
	data_eeprom_read();

	detectPresence();
	if (out_1wire){
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xBE);//READ SCRATCHPAD [BEh]
		readbyte(temperature);
		readbyte(temperature);
		readbyte(temperature);
		readbyte(temperature);
		readbyte(temperature);
		//byte 4 Configuration Register* 0x1F-9bit 94msek; 3F-10bit 188msek; 0x5F-11bit 375msek; 0x7F - 12 bit 750mSek;   		
		if ( temperature[0]!=0x7F ){
			scratchpad_save();//10ms
			_delay_ms(10);
			}
		}
	
	// 
	cli();
	WDTCR=(1<<WDCE)|(1<<WDE);
	WDTCR=(1<<WDP0)|(1<<WDE);//32mSek
	sei();
	
while(1)
	{
	if (TIFR & _BV(OCF1A)) // 0.001 sek
	{
	TIFR = _BV(OCF1A);	
	if ( --tLed == 0 )// 4ms
		{
		tLed=4;
		led_off();//  
		asm("wdr");//  
	
		skan_key();
		
		display();// . 
		if ( ++znmesto==3 )
			{
			znmesto=0;
			data_led();
			}
		
		}
	receive_t();
	
	if ( --t10ms==0 )
		{
		t10ms=10;
		time_wire--;
		TimeKey++;
	
		if (status_nagrev==3)
		{
		if ( power_flag==T_TOP ){
			if ( power<145 ) power++; else {power=220; power_flag=NAGREV_OFF;}
			}
		else
		if ( power_flag==T_BOTTOM ){
				uint8_t p=power;
				if ( p>tmp_power ) p--; 
				else 
				if ( p<tmp_power ) p++; 
				power=p;	
			}
		}
		
		if ( state==3)
		if (--time_blank==0)
			{
			if ( time_flag & _BV(_blank) )
			{//   
				time_flag &= ~_BV(_blank);
				time_blank=50;//0.5sek
			}
			else
			{
				time_flag |= _BV(_blank);
				time_blank=20;
			}
			}

		if ( alarm_T )
			{
			if ( --time_alarm == 0 )
				{
				if ( LATCH(SOUNDER) ){//  PORT_OUT & SOUNDER
					OFF(SOUNDER);//PORT_OUT &= ~SOUNDER;
					OFF(SOUNDER_LED);
					if ( alarm_T == 1 ) time_alarm=200;
						else time_alarm=50;
					}
					else{
					ON(SOUNDER);//PORT_OUT |= SOUNDER;
					ON(SOUNDER_LED);
					time_alarm=50;
					}
				}
			}
			else {time_alarm=1; OFF(SOUNDER); OFF(SOUNDER_LED);}
		
		}
	}
	}

}

